# Default key mapping for emacs run mode
#
# The file is in form 'key-spec': 'command-name' where:
#
#   key-spec is built from modifiers and key names, as found in pygtk's GDK.py
#   command-name is the name of one of the IDE's commands (see documentation)
#
# This can be copied and altered.  Lines beginning with '#' and blank lines
# are ignored.
#
# Use the gui.keymap preference to point Wing IDE at your copy of this file.  
#
# Note that this mapping and any derivatives make sense primarily for
# with edit.personality set to 'emacs' in your preferences.  Use file
# keymap.normal when running with a 'normal' personality.

'Down': 'next-line'
'Shift-Down': 'next-line-extend'
'KP_Down': 'next-line'
'Shift-KP_Down': 'next-line-extend'
'Ctrl-Down': 'next-line'

'Up': 'previous-line'
'Up': 'previous-line'
'Shift-Up': 'previous-line-extend'
'KP_Up': 'previous-line'
'Shift-KP_Up': 'previous-line-extend'
'Ctrl-Up': 'previous-line'
  
'Left': 'backward-char'
'Shift-Left': 'backward-char-extend'
'Ctrl-Left': 'backward-word'
'Ctrl-Shift-Left': 'backward-word-extend'
'Right': 'forward-char'
'Shift-Right': 'forward-char-extend'
'Ctrl-Right': 'forward-word'
'Ctrl-Shift-Right': 'forward-word-extend'
  
'Home': 'beginning-of-line'
'Shift-Home': 'beginning-of-line-extend'
'Ctrl-Home': 'start-of-document'
'Ctrl-Shift-Home': 'start-of-document-extend'
  
'End': 'end-of-line'
'Shift-End': 'end-of-line-extend'
'Ctrl-End': 'end-of-document'
'Ctrl-Shift-End': 'end-of-document-extend'

'Prior': 'backward-page'
'Shift-Prior': 'backward-page-extend'
  
'Next': 'forward-page'
'Page_Down': 'forward-page'
'Shift-Next': 'forward-page-extend'
'Shift-Page_Down': 'forward-page-extend'
  
'Ctrl-A': 'beginning-of-line'
'Ctrl-E': 'end-of-line'
'Ctrl-N': 'next-line'
'Ctrl-M': 'brace-match'
'Ctrl-P': 'previous-line'
'Ctrl-F': 'forward-char'
'Ctrl-B': 'backward-char'
'Ctrl-V': 'forward-page'
'Alt-V': 'backward-page'
'Ctrl-L': 'center-cursor'

# Editing
'Ctrl-Space': 'set-mark-command'
'Ctrl-G': 'stop-mark-command'
'Ctrl-W': 'cut'
'Ctrl-Y': 'yank-line'
'Alt-W': 'copy'
'Ctrl-D': 'forward-delete-char'
'Alt-D': 'forward-delete-word'
'Ctrl-K': 'kill-line'
'Delete': 'forward-delete-char'
'Shift-Delete': 'cut'
'Ctrl-Delete': 'forward-delete-word'
'Insert': 'toggle-overtype'
'Shift-Insert': 'paste'
'Ctrl-Insert': 'copy'
'Ctrl-H': 'backward-delete-char'
'BackSpace': 'backward-delete-char'
'Shift-BackSpace': 'backward-delete-char'
'Ctrl-BackSpace': 'backward-delete-word'
'Alt-BackSpace': 'backward-delete-word'
'Alt-Delete': 'backward-delete-word'
'Ctrl-Tab': 'forward-tab'
'Shift-Tab': 'backward-tab'
'Return': 'new-line'
'Shift-Return': 'new-line'
'Ctrl-Return': 'new-line'
'Alt-Return': 'new-line'
'KP_Enter': 'new-line'

# Special commands
'Ctrl-KP_Add': 'zoom-in'
'Ctrl-KP_Subtract': 'zoom-out'
'Ctrl-Alt-M': 'search-manager'
'Ctrl-S': 'search-forward'
'Ctrl-R': 'search-backward'
'Alt-percent': 'query-replace'
'Escape percent': 'query-replace'
'Alt-G': 'goto-line'
'Alt-L': 'goto-line'
'Ctrl-X Ctrl-S':'save'
'Ctrl-X Ctrl-C': 'quit'
'Ctrl-X Ctrl-F': 'open'
'Ctrl-X I': 'insert-file'
'Ctrl-X K': 'kill-buffer'
'Ctrl-X parenleft': 'start-kbd-macro'
'Ctrl-X parenright': 'stop-kbd-macro'
'Ctrl-X E': 'execute-kbd-macro'
'Ctrl-Slash': 'undo'
'Ctrl-X U': 'undo'
'Ctrl-Period': 'redo'
'Ctrl-C greater': 'indent-region'
'Ctrl-C less': 'outdent-region'
'Ctrl-C C': 'comment-out-region'
'Ctrl-C U': 'uncomment-out-region'
'Ctrl-C numbersign': 'comment-out-region'
'Ctrl-J': 'fill-paragraph'
'Escape Q': 'fill-paragraph'
#'Tab': 'forward-tab'
#'Ctrl-Tab': 'indent-to-match'
'Tab': 'indent-to-match'
'KP_Tab': 'indent-to-match'
'Ctrl-X 5 2': 'clone-window'
'Ctrl-X 5 0': 'delete-window'
'Ctrl-X L P': 'use-lexer-python'
'Ctrl-X L N': 'use-lexer-none'
'Ctrl-X L C': 'use-lexer-cpp'
'Ctrl-X L H': 'use-lexer-html'
'Ctrl-X L X': 'use-lexer-Xml'
'Ctrl-X L M': 'use-lexer-makefile'
'Ctrl-X L S': 'use-lexer-sql'
'Alt-Slash': 'fold-toggle'
'Alt-Right': 'fold-expand-more-current'
'Alt-Left': 'fold-collapse-more-current'
'Alt-Down': 'fold-expand-all-current'
'Alt-Up': 'fold-collapse-all-current'
'Alt-End': 'fold-expand-all'
'Alt-Home': 'fold-collapse-all'

'Ctrl-C numbersign': 'comment-out-region'
'Alt-X': 'command-by-name'
'Escape x': 'command-by-name'
'Escape g': 'goto-line'
'Escape 0': 'initiate-repeat-0'
'Escape 1': 'initiate-repeat-1'
'Escape 2': 'initiate-repeat-2'
'Escape 3': 'initiate-repeat-3'
'Escape 4': 'initiate-repeat-4'
'Escape 5': 'initiate-repeat-5'
'Escape 6': 'initiate-repeat-6'
'Escape 7': 'initiate-repeat-7'
'Escape 8': 'initiate-repeat-8'
'Escape 9': 'initiate-repeat-9'

'Ctrl-X B': 'switch-document'
'Ctrl-X Space': 'break-toggle' 

# F-keys
'F1': 'browse-project-modules'
'Shift-F1': 'show-project-window'
'F2': 'show-debug-window'
'Shift-F2': 'show-error-list'
'Ctrl-Shift-F2': 'show-expression-evaluator'
'Ctrl-Shift-F3': 'show-interactive-shell'
'Ctrl-Shift-F4': 'show-debug-probe'
'F3': 'break-set'
'Shift-F3': 'break-set-temp'
'Ctrl-F3': 'break-set-cond'
'F4': 'break-clear'
'Shift-F4': 'break-disable'
'Ctrl-Shift-F4': 'break-enable'
'Ctrl-F4': 'break-clear-all'
'Shift-F5': 'debug-start'
'F5': 'debug-continue'
'F6': 'debug-stop'
'Shift-F6': 'debug-kill'
'Ctrl-F6': 'debug-restart'
'F7': 'frame-up'
'F8': 'frame-down'
'F9': 'step-over'
'F10': 'step-into'
'F11': 'step-out'

'Ctrl-C Ctrl-C': 'debug-continue'
'Ctrl-C Ctrl-S': 'debug-stop'
'Ctrl-C Ctrl-K': 'debug-kill'

# Window short cuts:  Not real emacs bindings
'Ctrl-C Ctrl-D': 'show-debug-window'
'Ctrl-C Ctrl-B': 'browse-project-modules'
'Ctrl-C Ctrl-P': 'show-project-window'
'Ctrl-C Ctrl-E': 'show-error-list'
'Ctrl-C Ctrl-V': 'show-expression-evaluator'

'Ctrl-Pointer_Button3': 'goto-selected-symbol-defn'
